//********Created by Sotiriou Christos
//********(A.K.A.) Soulstorm
//******** http://users.forthnet.gr/ath/jonmecos

#ifndef ACCOUNT_M
#define ACCOUNT_M
#import "Account.h"


@implementation Account
-(void) setName: (NSString *) theName
{
	[theName retain];
	[accName release];
	
	accName = theName;
}

-(void) setDeposit: (NSNumber *)theDeposit
{
	[theDeposit retain];
	[accDeposit release];
	accDeposit = theDeposit;
}

-(void) setName: (NSString *) theName andDeposit: (NSNumber *) theDeposit
{
	[self setDeposit: theDeposit];
	[self setName: theName];
}

/*-(id) initWithName: (NSString *) theName andDeposit: (int) theDeposit
{
	self = [super init];
	[self setName: theName andDeposit: theDeposit];
	return self;
}*/


-(NSString *) accName
{
	return accName;
}

-(NSNumber *) accDeposit
{
	return accDeposit;
}

-(void) print
{
	printf("Name: %s\nDeposit: %i\n", [accName cString], accDeposit);
}

-(Account *) copyWithZone: (NSZone *) zone
{
	Account *newAccount = [[Account allocWithZone: zone] init];
	[newAccount setName: accName andDeposit: accDeposit];
	return newAccount;
}

-(NSComparisonResult) compareNames: (Account *) theAcc
{
	return [accName compare: [theAcc accName]];
}

-(NSComparisonResult) compareDeposits: (Account *) theAcc
{
	return [accDeposit compare: [theAcc accDeposit]];
}


-(void) encodeWithCoder: (NSCoder *) encoder
{
	[encoder encodeObject: [self accName]];
	[encoder encodeObject: [self accDeposit]];
}

-(id) initWithCoder: (NSCoder *) decoder
{
	[self setName: [decoder decodeObject]];
	[self setDeposit:[decoder decodeObject]];
	return self;
}


-(void) dealloc {
	printf(" account deallocating...\n");
	[accName release];
	[super dealloc];
}

@end
#endif