#import "MyDataSource.h"


@implementation MyDataSource

-(id) init {
	self = [super init];
	if (self != nil) {
		Account *one = [[Account alloc] init];
		Account *two = [[Account alloc] init];
		
		[one setName: @"Account1" andDeposit: [NSNumber numberWithFloat: 0.0]];
		[two setName: @"Account2" andDeposit: [NSNumber numberWithFloat: 0.0]];
		
		AccArray = [[NSMutableArray alloc] init];
		[AccArray addObject: one];
		[AccArray addObject: two];
		[one release];
		[two release];
		NSNotificationCenter* nc=[NSNotificationCenter defaultCenter];
		[nc addObserver:self selector:@selector(searchStarted:) name:@"SearchStartedNotification" object:nil];
	}
	return self;
}

- (void) dealloc;
{
	[AccArray release];
	NSNotificationCenter* nc=[NSNotificationCenter defaultCenter];
	[nc removeObserver:self];
	[super dealloc];
}

- (void) searchStarted:(NSNotification*) notification;
{
	NSString* value=[notification object];
	NSLog (@"search started with: %@", value);
}
	

-(int)numberOfRowsInTableView:(NSTableView *)tableView
{
	return [AccArray count];
}

-(id)tableView:(NSTableView *)tableView
objectValueForTableColumn:(NSTableColumn *)tableColumn
		   row: (int) row
{
	NSString *identifier = [tableColumn identifier];
	Account *acc = [AccArray objectAtIndex: row];
	return [acc valueForKey: identifier];
}


-(void)tableView:(NSTableView *)tableView
  setObjectValue: (id)object
  forTableColumn: (NSTableColumn *)tableColumn
			 row:(int) row
{
	NSString *identifier = [tableColumn identifier];
	Account *acc = [AccArray objectAtIndex: row];
	[acc takeValue: object forKey: identifier];
}

-(IBAction)addButtonPressed:(id)sender{
	Account *acc = [[Account alloc] init];
	[acc setName: @"NewAcc"];
	[acc setDeposit: [NSNumber numberWithFloat: 0.0]];
	[AccArray insertObject: acc atIndex: 0];
	[acc release];
	[Accs reloadData];
	[Accs selectRow: 0 byExtendingSelection:NO];
}

-(IBAction)removeButtonPressed:(id)sender
{
	[AccArray removeObjectAtIndex: [Accs selectedRow]];
	[Accs reloadData];
}

-(IBAction)save:(id)sender
{
	NSSavePanel *savePanel = [NSSavePanel savePanel];
	SEL sel = @selector(savePanelDidEnd:returnCode:contextInfo:);
	[savePanel beginSheetForDirectory:@"~/Documents"
								 file:@"Bank.accounts" 
					   modalForWindow:[Accs window]
						modalDelegate:self 
					   didEndSelector:sel
						  contextInfo:nil];
}

-(void)savePanelDidEnd:(NSSavePanel *)sheet
			returnCode:(int)returnCode
		   contextInfo:(void *)conext
{
	if(returnCode == NSOKButton){
		[NSArchiver archiveRootObject: AccArray toFile: [sheet filename]];
	}
}

-(IBAction)load:(id) sender
{
	NSOpenPanel *openPanel = [NSOpenPanel openPanel];
	SEL sel = @selector(openPanelDidEnd:returnCode:contextInfo:);
	[openPanel beginSheetForDirectory:@"~/Documents"
								 file:nil
								types:nil 
					   modalForWindow:[Accs window]
						modalDelegate:self
					   didEndSelector:sel
						  contextInfo:nil];
}

-(void)openPanelDidEnd: (NSOpenPanel *)sheet
			returnCode:(int)returnCode
		   contextInfo:(void *)contextInfo;
{
	if(returnCode == NSOKButton){
		NSMutableArray *array;
		array = [NSUnarchiver unarchiveObjectWithFile: [sheet filename]];
		[array retain];
		[AccArray release];
		AccArray = array;
		[Accs reloadData];
	}
}

-(void)tableView: (NSTableView *)tableView
didClickTableColumn: (NSTableColumn *)tableColumn

{
	NSString *identifier = [tableColumn identifier];
	if([identifier isEqualToString: @"accName"]){
		[AccArray sortUsingSelector: @selector(compareDeposits:)];
	}
	else{
		[AccArray sortUsingSelector: @selector(compareNames:)];
	}
	[Accs reloadData];
}

-(IBAction)search:(id)sender
{
	printf("looking up %s", [WindowController returnTextValue]);
	
}

@end
